#include "FileManipulationNotifier.hpp"

#include <iostream>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
using namespace std;

FileManipulationNotifier *fileManipulationNotifier;

FileManipulationNotifier::FileManipulationNotifier( AdrManagerStub & stub, const string & fifoName, int ckpReposId ) : adrManagerStub_ (stub) {
    this->fifoName_ = fifoName;    
    this->ckpReposId_ = ckpReposId;
}

FileManipulationNotifier::~FileManipulationNotifier() {
    
}

void FileManipulationNotifier::notifierLoop () {
    
    int bufferSize = 5000;
    char *readBuffer = new char[bufferSize];
    ssize_t nBytesWritten = 0;
    //char *numberBuffer = new char[sizeof(ssize_t)+1];
    //numberBuffer[sizeof(ssize_t)] = '\0';
     
    std::cout << "Starting notifier loop. "  << sizeof(ssize_t) << std::endl;
             
    while (true) {
        
        int fifofd = open( fifoName_.c_str(), O_RDONLY );
        int nbytes = read(fifofd, readBuffer, bufferSize);
        
        for ( int pos=0; pos < nbytes; pos += sizeof(ssize_t) )  {
            memcpy(&nBytesWritten, &(readBuffer[pos]), sizeof(ssize_t));
            //cerr << "nBytesWritten=" << nBytesWritten << " !" << endl;
            adrManagerStub_.setFragmentStored(ckpReposId_, nBytesWritten);
        }
             
    }
    
    delete[] readBuffer;
    //delete[] numberBuffer;
}

void *FileManipulationNotifier::run( void *ptr ) {
    fileManipulationNotifier->notifierLoop();
    return NULL;
}


void FileManipulationNotifier::launchFileManipulationNotifier( AdrManagerStub & stub, const string & fifoName, int ckpReposId ) {
    
    fileManipulationNotifier = new FileManipulationNotifier( stub, fifoName, ckpReposId );

    pthread_t thread1;
    pthread_create( &thread1, NULL, FileManipulationNotifier::run, NULL);
    pthread_detach(thread1);
}
