#ifndef _ADRDATATRANSFERSTUB_HPP_
#define _ADRDATATRANSFERSTUB_HPP_

#include <string>
using namespace std;

class AdrDataTransferStub {

    int sockfdTemp;  
    int connectToServer(string ipAddress, short port);

public:
    AdrDataTransferStub() : sockfdTemp(0){}
  
    /**
     * Transfer the checkpoint ckpNumber from 'data' to ipAddress:portNumber.
     * Returns the number of transfered bytes or -1 if a failure occurs;
     */  
    int transferData(const string & ipAddress, short portNumber, const char *fragmentId, int fragmentIdSize, const void *data, long nbytes);
  
    int prepareDataTransfer(const string & ipAddress, short portNumber);
    int performDataTransfer(int sockfd, const void *data, long nbytes);
    int performDataTransferInc(int sockfd, const void *data, long nbytes, long *availableBytes);    
    int finishDataTransfer(int sockfd, const char *fragmentId, int fragmentIdSize);
      
    /**
     * Reads the checkpoint ckpNumber from ipAddress:portNumber and puts into 'data'.
     * Returns the number of bytes read or -1 if a failure occurs;
     */
    int readData(const string & ipAddress, short portNumber, const char *fragmentId, int fragmentIdSize, void * & data, int & dataSize, long *availableBytes);
  
};

#endif /*_ADRDATATRANSFER_HPP_*/
