#include "BrokerServerManager.hpp"

BrokerServerManager::BrokerServerManager() {
    
    storageManager   = new DataStorageManager();
    retrievalManager = new DataRetrievalManager();
    
    Config config("broker.conf");
    AccessBrokerSkeleton::init(retrievalManager, storageManager, config);    
    CdrmRequestsStub *cdrmRequestsStub = new CdrmRequestsStub(config, 20);
    AdrDataTransferStub *adrDataTransferStub = new AdrDataTransferStub();
    
    storageManager->setCdrmRequestStub(cdrmRequestsStub, adrDataTransferStub);    
    retrievalManager->setCdrmRequestStub(cdrmRequestsStub, adrDataTransferStub);
}

BrokerServerManager::~BrokerServerManager() {
    
}

DataStorageManager *BrokerServerManager::getStorageManager() {
    return storageManager;
}

DataRetrievalManager *BrokerServerManager::getRetrievalManager() {
    return retrievalManager;
}
