#ifndef CODEDDATAINFO_HPP_
#define CODEDDATAINFO_HPP_

#include <vector>
#include <pthread.h>
using namespace std;

class DataOperationCallback {
public:    
    virtual ~DataOperationCallback() {}
    virtual void finishedDataOperation( class CodedDataInfo *dataInfo, int status ) = 0;
};

class CodedDataInfo {
public:
    const char *fileKey;
    vector<char *> encData;

    // Used to control the amount of bytes already coded/downloaded
    vector<long *> availableBytes;

    vector<int> fragmentSizeList;
    vector<char *> fragmentKeyList;
    vector<string> adrAddresses;
    
    // Used by RetrievalRequest
    vector<int> recoveredFragmentIndexes;    
    int neededFragments;
    void *data;
    long dataSize;
    
    int *remainingUploads;
    int *remainingDownloads;
    int *remainingCodings;
    
    DataOperationCallback *operationCallback;
    void (*appCallback) (int);
    pthread_mutex_t *callerMutex;
    pthread_cond_t  *callerCond;
    
    CodedDataInfo() : appCallback (NULL), callerMutex(NULL), callerCond(NULL) {}  
};

#endif /*CODEDDATAINFO_HPP_*/
