#ifndef FRAGMENTDOWNLOADTHREAD_HPP_
#define FRAGMENTDOWNLOADTHREAD_HPP_

#include "CodedDataInfo.hpp"
#include "AdrDataTransferStub.hpp"
#include "DataRetrievalManager.hpp"

#include <vector>
using namespace std;

class FragmentDownloadThread
{
    
    string ipAddress;
    short portNumber;
    
    char *hashKey;
    
    CodedDataInfo *dataInfo;
    
    int fragmentSize;
    int fragmentPos;
    int fragmentNumber;
    
    int *remainingDownloads;
    
    FragmentDownloadThread( string ipAddress_, short portNumber_, int fragmentNumber_, CodedDataInfo *dataInfo_, int fragmentPos_ );
    
public:
	virtual ~FragmentDownloadThread();
    
    static void *run( void *ptr );
    
    /**
     * Used only in the experiments
     */
    static int setAllowedAdrs(vector<string> & allowedAdrs);
    
    static void *launchDownloadThread( void *ptr );
    
    static void configureDownloadThreads( AdrDataTransferStub *adrDataTransferStub_, DataRetrievalManager *dataRetrievalManager_ );
    
    void performDownload();
};

#endif /*FRAGMENTDOWNLOADTHREAD_HPP_*/
