#ifndef FRAGMENTUPLOADTHREAD_HPP_
#define FRAGMENTUPLOADTHREAD_HPP_

#include "AdrDataTransferStub.hpp"
#include "DataStorageManager.hpp"
#include "CodedDataInfo.hpp"
#include "utils/c++/CdrmRequestsStub.hpp"

#include <string>
#include <vector>
using namespace std;

class FragmentUploadThread
{
    string ipAddress;
    short portNumber;
    
    unsigned char *fragmentKey;
    
    char *encData;
    int fragmentSize;
    int fragmentNumber;

    long *availableBytes;
    
    int *remainingUploads;
    
    FragmentUploadThread( string ipAddress_, short portNumber_, unsigned char *fragmentKey_, char *encData_, int fragmentSize_, int fragmentNumber_, int *remainingUploads_, long *availableBytes_);
    
public:
	
    static void *run( void *ptr );
    
    static void *launchUploadThread ( void *ptr );
    
    void performUpload();
    
    static void configureUploadThreads( CdrmRequestsStub *cdrmRequestsStub_, AdrDataTransferStub *adrDataTransferStub_, DataStorageManager *dataStorageManager_ );
    
	virtual ~FragmentUploadThread();
};

#endif /*FRAGMENTUPLOADTHREAD_HPP_*/
