#include "OppStoreBroker.h"
#include "StorageRequestIda.hpp"
#include "RetrievalRequestIda.hpp"
#include "BrokerServerManager.hpp"

/**
 * setAllowedAdrs
 */  
#include "FragmentDownloadThread.hpp"

#include <pthread.h>

BrokerServerManager *brokerServerManager = NULL;
StorageRequestIda   *storageRequestIda   = NULL;
RetrievalRequestIda *retrievalRequestIda = NULL;

int launchBroker() {
    brokerServerManager = new BrokerServerManager();
    storageRequestIda   = new StorageRequestIda  ( 2, 5, brokerServerManager->getStorageManager()   );
    retrievalRequestIda = new RetrievalRequestIda( 2, 5, brokerServerManager->getRetrievalManager() );
    return 0;
}

int storeData(char * & key, void *data, long dataSize, void(*appCallback)(int)) {
    if (storageRequestIda == NULL) launchBroker();
    storageRequestIda->storeData(key, data, dataSize, appCallback, false);
    return 0;
}

int storeDataW(char * & key, void *data, long dataSize, void(*appCallback)(int)) {
    if (storageRequestIda == NULL) launchBroker();
    storageRequestIda->storeData(key, data, dataSize, appCallback, true);
    return 0;
}

int retrieveDataW(const char * key, void * & data, long & dataSize, void(*appCallback)(int)) {
    if (retrievalRequestIda == NULL) launchBroker();
    retrievalRequestIda->retrieveData(key, data, dataSize, appCallback, true);
    return 0;
    
}

int setAllowedAdrs(vector<string> & allowedAdrs) {
    return FragmentDownloadThread::setAllowedAdrs(allowedAdrs);
}
