#ifndef RETRIEVALREQUESTIDA_HPP_
#define RETRIEVALREQUESTIDA_HPP_

#include "ida/IDAImpl.h"
#include "CodedDataInfo.hpp"
#include "DataRetrievalManager.hpp"

class RetrievalRequestIda : public DataOperationCallback {
    
    int totalFragments_;
    int neededFragments_;
    DataRetrievalManager *dataRetrievalManager_;
    IDAImpl *idaImpl;
    bool dataInfoFreed;
    
    void releaseMemory( CodedDataInfo *dataInfo );
    
public:
	RetrievalRequestIda(int neededFragments, int totalFragments, DataRetrievalManager *dataRetrievalManager);
	virtual ~RetrievalRequestIda();
    
    void retrieveData (const char *id, void * & data, long & dataSize, void(*appCallback)(int), bool wait);
    
    void finishedDataOperation( CodedDataInfo *dataInfo, int status );
    
};

#endif /*RETRIEVALREQUESTIDA_HPP_*/
