  #######################################################################################
  #alter a string in order to set paths in scripts
  #params:
  # filepath - the file to be altered
  # srcString - string to be replaced
  # dstString - replacement
  alterString(){

    local filepath=${1}
    local srcString=${2}
    local dstString=${3}

    sed s#"${srcString}"#"${dstString}"# \
    < ${filepath} > ${filepath}".tmp"
    cp ${filepath}".tmp" ${filepath}
    rm -f ${filepath}".tmp"
  }

  # MAIN BODY OF THE SCRIPT
  #
  echo "This script will configure compile and install lua-5.1.1 with:"
  echo "   -> luasocket-2.0"
  echo "   -> oil-0.3.4-alpha"
  echo ""
  echo "Enter the full path where OppStore is located:"
  read -e luaPath

  if ! test -d ${luaPath}; then
      echo "Invalid directory: $luaPath"
      exit
  fi

  luaPath=$luaPath"/lua"
  if ! test -d ${luaPath}; then
      mkdir ${luaPath}
  fi

  # Cconfiguring lua
  alterString "lua-5.1.1/Makefile" "INSTALL_TOP=.*" "INSTALL_TOP=${luaPath}"
  # Configuring luasocket
  alterString "luasocket-2.0/config" "LUA_HOME=.*" "LUA_HOME=${luaPath}"
  # Configuring oil
  alterString "oil-0.3.4-alpha/config" "LUA_HOME=.*" "LUA_HOME=${luaPath}"

  # Compiling lua
  cd lua-5.1.1
  make linux install
  make clean
  cd ..
  # Compiling luasocket
  cd luasocket-2.0
  make
  make install
  cp src/luasocket.h ${luaPath}/include/
  dir=`pwd`
  cd ${luaPath}/lib
  ln -s socket/core.so libluasocket.so
  cd ${dir}
  make clean
  cd ..
  # Compiling oil
  cd oil-0.3.4-alpha
  make preload
  make installp
  make clean
  cd ..
