package br.usp.ime.oppstore.adrmanager;

import java.util.TreeMap;

import rice.p2p.commonapi.Id;

public class FragmentLivenessMonitor extends Thread {

	StoredFragmentManager fragmentManager;

	TreeMap<Long, Id> livenessMap;
	
	public FragmentLivenessMonitor( StoredFragmentManager fragmentManager ) {
		
		this.livenessMap = new TreeMap<Long, Id>(); 
		this.fragmentManager = fragmentManager;		
	}
	
	public void addLivenessTimeout ( int timeoutMinutes, Id fragmentId ) {
		
		long absoluteTimeOut = System.currentTimeMillis() + ( timeoutMinutes * 60 * 1000 );
		synchronized (livenessMap) {
			livenessMap.put( absoluteTimeOut, fragmentId );	
		}
		
		//System.out.println("ADDED LIVENESS TIME -> currentTime:" + System.currentTimeMillis() + " absoluteTimeOut:" + absoluteTimeOut );
	}
	
	public void run() {
	
		//System.out.println("Fragment monitor started!");
		
		while (true) {
			try { Thread.sleep(30 * 1000); } catch (InterruptedException e) {}
			
			long currentTime = System.currentTimeMillis();
			synchronized (livenessMap) {

				while( livenessMap.size() > 0 && currentTime > livenessMap.firstKey() ) { 
					
					Id fragmentId = livenessMap.remove( livenessMap.firstKey() );
					AdrInformationStructure adrInfo = fragmentManager.getAdrInfo( fragmentId );
					if (adrInfo != null)
						adrInfo.fragmentRemovalList.add( fragmentId );					
				}
			}	
		}
	}
}
