package br.usp.ime.oppstore.adrmanager;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import br.usp.ime.oppstore.FileFragmentIndex;
import br.usp.ime.oppstore.adrmanager.AdrInformationStructure;

import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.NodeHandleSet;

/**
 *  Perform management of data stored in the CDRM.
 *  It contains the locations of fragments contents.
 *  Is initialized by the AdrManager
 */
public class StoredFragmentManager {
    
    /**
     * Maintains the addresses of the ADR where fragments are stored 
     */
    HashMap <Id, AdrInformationStructure> fragmentLocationMap;
    
    FragmentLivenessMonitor livenessMonitor;
        
    public StoredFragmentManager () {
        fragmentLocationMap = new HashMap <Id, AdrInformationStructure>();
        livenessMonitor = new FragmentLivenessMonitor( this );
        livenessMonitor.start();
    }
    
    public void setFragmentLocation (Id fragmentId, AdrInformationStructure adrInfo, int timeoutMinutes) {        
        fragmentLocationMap.put(fragmentId, adrInfo);
        livenessMonitor.addLivenessTimeout(timeoutMinutes, fragmentId);
    }
    
    public AdrInformationStructure getAdrInfo(Id fragmentId) {
        return fragmentLocationMap.get(fragmentId);
    }    
    
    public void setFragmentTimeoutExpired (Id fragmentId) {
    	AdrInformationStructure adrInfo = fragmentLocationMap.get( fragmentId );
    	if ( adrInfo != null )
    		adrInfo.fragmentRemovalList.add( fragmentId );
    }
    
}
