package br.usp.ime.oppstore.message;

import br.usp.ime.oppstore.FileFragmentIndex;
import rice.p2p.commonapi.Id;
import rice.p2p.commonapi.Message;
import rice.p2p.commonapi.NodeHandle;

/**
 * Communicates with the Pastry network
 *
 * @version February, 09 of 2006
 * @author Raphael Camargo
 */
public class FileFragmentIndexMessage extends CdrmMessage {
    
    private static final long serialVersionUID = 5746248244038506602L;

    public static final int ffiRoutingSpaceNumber = 0;
    
    public Id fileId;
    public int numberOfReplicas;
    public FileFragmentIndex fileFragmentIndex;
    public boolean isStoreRequest;    
    
    public boolean isReplicaStoreRequest;

    /**
     * 
     * @param fileId
     * @param sourceCdrmHandle
     * @param fileInformationStructure The FileInformationStructure to be stored  
     */
    public FileFragmentIndexMessage ( 
            Id fileId, FileFragmentIndex fileInformationStructure,
            boolean isStoreRequest, int numberOfReplicas, 
            NodeHandle sourceCdrmHandle, int requestNumber ) {        
        super(sourceCdrmHandle, ffiRoutingSpaceNumber, requestNumber);
        
        this.isStoreRequest = isStoreRequest;
        this.numberOfReplicas = numberOfReplicas;
        this.fileId = fileId;
        this.fileFragmentIndex = fileInformationStructure;
        
        this.isReplicaStoreRequest = false;
    }    

    public FileFragmentIndexMessage (FileFragmentIndexMessage fileInformationMessage) {
        super(fileInformationMessage.sourceHandle, ffiRoutingSpaceNumber, fileInformationMessage.messageNumber);
        
        this.fileId = fileInformationMessage.fileId; 
        this.numberOfReplicas = fileInformationMessage.numberOfReplicas; 
        this.fileFragmentIndex = fileInformationMessage.fileFragmentIndex;
        this.isStoreRequest = fileInformationMessage.isStoreRequest;    
        
        this.isReplicaStoreRequest = fileInformationMessage.isReplicaStoreRequest;
        this.isResponse = fileInformationMessage.isResponse;
    }

    /**
     * From pastry's Message interface
     *
     * @return The priority of this message
     */
    public byte getPriority() {
        return Message.LOW_PRIORITY;
    }
        
    public String toString() {
        return "StoreFileInformationMessage(" + messageNumber + ")";
    }

}
