#ifndef CdrmRequestsStub_HPP
#define CdrmRequestsStub_HPP

#include <string>
#include <vector>
#include <pthread.h>
#include "utils/c++/Config.hpp"
struct lua_State;

using namespace std;

class CdrmRequestsStub{

private:
    struct lua_State * state;
    pthread_mutex_t * stubMutex;
    int keySize;

public:
    CdrmRequestsStub(const Config & config, int keySize);

    void setFragmentStorageFinished( const int & requestNumber, const vector<int> & notStoredFragmentList, const vector<char *> & fragmentHashList);

    int requestFileStorage(const char * & fileKey, const vector<char *> & fragmentKeyList, int fileSize, const vector<int> & fragmentSizeList,
                           const string & accessBrokerIor, int timeoutMinutes, bool storeGlobal);
                
    int requestFileRetrieval(const char * & fileKey, const string & accessBrokerIor);
};

#endif // CkpReposStub_HPP


